//+------------------------------------------------------------------+
//|                               MTF_Cycle_Point_KROUFR_version.mq4 |
//+------------------------------------------------------------------+
#property  copyright "Copyright  2008 | Grayman77, zIG, akadex"
#property  link      "ForexResearch"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Blue
#property indicator_color2 Red
#property indicator_color3 SteelBlue
#property indicator_color4 IndianRed
#property indicator_width1 0
#property indicator_width2 0
#property indicator_width3 1
#property indicator_width4 1

#property indicator_level1 80
#property indicator_level2 20
#property indicator_level3 50

//----  
extern double hZone=50;
extern double lZone=50;
extern int Period1=60;
extern int Period3=240;
extern int BarsCross=0;
extern int PriceHL=0;  // 0 - min/max-hi/lo // /  /
                       // 1 - min/max c/open (depending  which is lower  // /  / (   )
extern int PointTotal=3; // points 4 search amount //   
extern bool Comments1=false;
//----
extern int FastMA=12;
extern int SlowMA=24;
extern int Crosses=50;
extern bool Comments=true; 

extern bool alertsOn      = false;
extern bool alertsMessage = true;
extern bool alertsSound   = false;
extern bool alertsEmail   = false;

//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double h[],l[];

//---- var
int ShiftH[],ShiftL[];
double PriceH[], PriceL[],atr;
double zD1h[],zD1l[],zD1ShiftH[],zD1ShiftL[],zD1PriceH[],zD1PriceL[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(7);
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexBuffer(0,h);
   SetIndexArrow(0,110);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexBuffer(1,l);
   SetIndexArrow(1,110);
   SetIndexStyle(2,DRAW_ARROW);
   SetIndexBuffer(2,zD1h);
   SetIndexArrow(2,168);//110
   SetIndexStyle(3,DRAW_ARROW);
   SetIndexBuffer(3,zD1l);
   SetIndexArrow(3,168);//110
   SetIndexBuffer(4,ExtMapBuffer1);
   SetIndexBuffer(5,ExtMapBuffer2);
   SetIndexBuffer(6,ExtMapBuffer3);

   //   
   ArrayResize(ShiftH,PointTotal);
   ArrayResize(ShiftL,PointTotal);
   ArrayResize(PriceH,PointTotal);
   ArrayResize(PriceL,PointTotal);

   ArrayResize(zD1ShiftH,PointTotal);
   ArrayResize(zD1ShiftL,PointTotal);
   ArrayResize(zD1PriceH,PointTotal);
   ArrayResize(zD1PriceL,PointTotal);

   SetIndexEmptyValue(0,0.0);
   SetIndexEmptyValue(1,0.0);
   SetIndexEmptyValue(2,0.0);
   SetIndexEmptyValue(3,0.0);

   SetIndexLabel(0,"H");
   SetIndexLabel(1,"L");
   SetIndexLabel(2,"zD1H");
   SetIndexLabel(3,"zD1L");



//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   //ObjectsDeleteAll();
    Comment("");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
   int i,limit;
   double vtmp1,vtmp2;

   int finalSignal=0;
   int zTrendH4=0; //       4  1 
   int zTrendD1=0; //
   int zPhaseCnt=1;
   int zH4PhaseCnt=1;
   int zLastH4Bar=0;
   int zContTrend=0;

   int j;
   int hvar=0;
   int lvar=0;

   int hClose,hOpen,lClose,lOpen;

//----    
   if(counted_bars<0) return(-1);

//----     
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   if(limit>Bars-2) limit=Bars-2;
//----

   for(i=limit;i>0;i--)
     {
      datetime _TimeBar=Time[i];
      // current bar shift on 2 higher shi     2 
      int Shift=iBarShift(Symbol(),Period1,_TimeBar,false);
      int Shift3=iBarShift(Symbol(),Period3,_TimeBar,false)+1;

      double v1=iCustom(Symbol(),Period1,"Cycle_KROUFR_version_",FastMA,SlowMA,Crosses,Comments,0,Shift);
      double v3=iCustom(Symbol(),Period3,"Cycle_KROUFR_version_",FastMA,SlowMA,Crosses,Comments,0,Shift3);

      ExtMapBuffer1[i]=v1;
      ExtMapBuffer3[i]=v3;
      h[i]    = 0;
      l[i]    = 0;
      zD1h[i] = 0;
      zD1l[i] = 0;
     }

   for(i=limit;i>0;i--)
     {

      //for current TF    
      // if on 2 last bars crooked line crosses hZone level down         hZone  
      if(ExtMapBuffer1[i]<hZone && ExtMapBuffer1[i+1]>hZone)
        {
         // find nearwest cross hZone level up      hZone  
         j=i+2;
         while(ExtMapBuffer1[j]>hZone && j<Bars-2) j++;
         j--; //reduce shift on 1   1  

         //  find max price between crosses      
         if(PriceHL==0)
            hvar=iHighest(Symbol(),Period(),MODE_HIGH,j-i,i);
         if(PriceHL==1)
           {
            hClose=iHighest(Symbol(),Period(),MODE_CLOSE,j-i,i);
            hOpen=iHighest(Symbol(),Period(),MODE_OPEN,j-i,i);
            if(Close[hClose]>Open[hOpen]) hvar=hClose;
            else hvar=hOpen;
           }
         // put point (in the buffer)   ( )
         if(j-i>BarsCross)
           {
            h[hvar]=High[hvar]+10*Point;
            //find nearest points  PointTotal - upper points   PointTotal  
            FindCrossH(i);
           }
        }

      // if on last 2 bars lZone crossed down         lZone  
      if(ExtMapBuffer1[i]>lZone && ExtMapBuffer1[i+1]<lZone)
        {
         // nearest lZone down cross      lZone  
         j=i+2;
         while(ExtMapBuffer1[j]<lZone && j<Bars-2) j++;
         j--; // reduce shift  on 1     1  

         // min price between crosses     
         if(PriceHL==0)
            lvar=iLowest(Symbol(),Period(),MODE_LOW,j-i,i);
         if(PriceHL==1)
           {
            lClose=iLowest(Symbol(),Period(),MODE_CLOSE,j-i,i);
            lOpen=iLowest(Symbol(),Period(),MODE_OPEN,j-i,i);
            if(Close[lClose]<Open[lOpen]) lvar=lClose;
            else lvar=lOpen;
           }
         // put dot on the buffer   ( )
         if(j-i>BarsCross)
           {
            l[lvar]=Low[lvar]-10*Point;
            // nearest lower dots   PointTotal  
            FindCrossL(i);
           }
        }

      // 4 d1   D1
      //         hZone  
      if(ExtMapBuffer3[i]<hZone && ExtMapBuffer3[i+1]>hZone)
        {
         //      hZone  
         j=i+2;
         while(ExtMapBuffer3[j]>hZone && j<Bars-2) j++;
         j--; //   1  

         //     
         if(PriceHL==0)
            hvar=iHighest(Symbol(),Period(),MODE_HIGH,j-i,i);
         if(PriceHL==1)
           {
            hClose=iHighest(Symbol(),Period(),MODE_CLOSE,j-i,i);
            hOpen=iHighest(Symbol(),Period(),MODE_OPEN,j-i,i);
            if(Close[hClose]>Open[hOpen]) hvar=hClose;
            else hvar=hOpen;
           }
         //   ( )
         if(j-i>BarsCross)
           {
            zD1h[hvar]=High[hvar]+10*Point;
            //   PointTotal  
            FindCrossD1H(i);
           }
        }

      //         lZone  
      if(ExtMapBuffer3[i]>lZone && ExtMapBuffer3[i+1]<lZone)
        {
         //      lZone  
         j=i+2;
         while(ExtMapBuffer3[j]<lZone && j<Bars-2) j++;
         j--; //   1  

         //     
         if(PriceHL==0)
            lvar=iLowest(Symbol(),Period(),MODE_LOW,j-i,i);
         if(PriceHL==1)
           {
            lClose=iLowest(Symbol(),Period(),MODE_CLOSE,j-i,i);
            lOpen=iLowest(Symbol(),Period(),MODE_OPEN,j-i,i);
            if(Close[lClose]<Open[lOpen]) lvar=lClose;
            else lvar=lOpen;
           }
         //   ( )
         if(j-i>BarsCross)
           {
            zD1l[lvar]=Low[lvar]-10*Point;
            //   PointTotal  
            FindCrossD1L(i);
           }
        }

      if (!IsTesting() && Comments1)
        {
         Comment ("\nLast High "+PriceH[0]+" on Bar # "+ShiftH[0]+
                  "\nLast Low  "+PriceL[0]+" on Bar # "+ShiftL[0]+
               "\n\nPrevious High "+PriceH[1]+" on Bar # "+ShiftH[1]+
                 "\nPrevious Low  "+PriceL[1]+" on Bar # "+ShiftL[1]);
        }
     }

   //
   //
   //
   //
   //
   
   if (alertsOn)
   {
      int max = MathMax(ShiftH[1],ShiftH[1]);
      for (i=0; i<max; i++) if (h[i] !=0 || l[i] !=0 || zD1h[i] != 0 || zD1l[i] != 0) break;
         if (h[i]    != 0) doAlert(i,"minor down");
         if (l[i]    != 0) doAlert(i,"minor up");
         if (zD1h[i] != 0) doAlert(i,"major down");
         if (zD1l[i] != 0) doAlert(i,"major down");
   }   
   
//----
   return(0);
  }

//+------------------------------------------------------------------+
//|  searching history PointTotal last pois buff h[]   PointTotal    h[]        |
//|  & PointTotal last points l[]PointTotal    l[].                        |
//|   save glob var params 4 dots :      .  . :|
//|   -  ShiftH[],ShiftL[];                                  |
//|   -  PriceH[] (High[]  h[]), PriceL[] (Low[]  l[])     |
//|                                                                  |
//+------------------------------------------------------------------+
void FindCrossH(int _Shift)
  {
   int i,j;
   int k;  //     

   //  
   for(i=0;i<PointTotal;i++)
     {
      ShiftH[i]=0;
      PriceH[i]=0.;
     }

   //   

   i=_Shift; // 
   j=-1; //  
   while(j<PointTotal) //      
     {
      //while(h[i]<0.00001 && i<Bars-2) i++;
      while(h[i]==0. && i<Bars-2) i++;
      j++; //  j- 
      ShiftH[j]=i;
      PriceH[j]=High[i];
      i++; //    1
     }

   return;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void FindCrossD1H(int _Shift)
  {
   int i,j;
   int k;  //     

   //  
   for(i=0;i<PointTotal;i++)
     {
      zD1ShiftH[i]=0;
      zD1PriceH[i]=0.;
     }

   //   

   i=_Shift; // 
   j=-1; //  
   while(j<PointTotal) //      
     {
      //while(h[i]<0.00001 && i<Bars-2) i++;
      while(zD1h[i]==0. && i<Bars-2) i++;
      j++; //  j- 
      zD1ShiftH[j]=i;
      zD1PriceH[j]=High[i];
      i++; //    1
     }

   return;
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void FindCrossL(int _Shift)
  {
   int i,j;
   int k;  //     

   //  
   for(i=0;i<PointTotal;i++)
     {
      ShiftL[i]=0;
      PriceL[i]=0.;
     }

   //   

   i=_Shift; // 
   j=-1; //  
   while(j<PointTotal) //      
     {
      //while(l[i]<0.00001 && i<Bars-2) i++;
      while(l[i]==0. && i<Bars-2) i++;
      j++; //  j- 
      ShiftL[j]=i;
      PriceL[j]=Low[i];
      i++; //    1

     }
   //   
   return;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void FindCrossD1L(int _Shift)
  {
   int i,j;
   int k;  //     

   //  
   for(i=0;i<PointTotal;i++)
     {
      zD1ShiftL[i]=0;
      zD1PriceL[i]=0.;
     }

   //   

   i=_Shift; // 
   j=-1; //  
   while(j<PointTotal) //      
     {
      //while(l[i]<0.00001 && i<Bars-2) i++;
      while(zD1l[i]==0. && i<Bars-2) i++;
      j++; //  j- 
      zD1ShiftL[j]=i;
      zD1PriceL[j]=Low[i];
      i++; //    1

     }
   //   
   return;
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+  
//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," cycle point kroufr ",doWhat," from : ",TimeToStr(previousTime,TIME_DATE|TIME_SECONDS));
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"cycle point kroufr "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}

